""" event base class """

__version__ = 1

def __dir__():
    return ("Event", ) 

## imports

from .command import Command

import threading

## classes

class Event(Command):

    def __init__(self):
        super().__init__()
        self.batch = False
        self.direct = False
        self.type = "chat"

    def ok(self, txt):
        self.reply("ok %s" % txt)

    def prompt(self):
        pass

    def reply(self, txt):
        from ob import k
        self._result.append(txt)
        if self.direct:
            bot = k.fleet.get_bot(self.orig)
            bot.say(self.channel, txt, self.type)
        elif not self.batch:
            k.fleet.say(self.orig, self.channel, txt, self.type)

    def wait(self):
        self._ready.wait()
        result = []
        thrs = []
        next = []
        for thr in self._thrs:
            try:
                ret = thr.join()
            except RuntimeError:
                next.append(thr)
                continue
            thrs.append(thr)
        for n in next:
            try:
                n.join()
            except RuntimeError:
                pass
        for thr in thrs:
            self._thrs.remove(thr)
        return self
