""" module loader. """

__version__ = 1

## imports

import importlib
import importlib.util
import ob
import os

importlib.invalidate_caches()

## defines

def __dir__():
    return ("Loader", "table")

table = {}

## classes

class Loader(ob.Object):

    def direct(self, name):
        return importlib.import_module(name)

    def fromfile(self, modname):
        p = os.path.join(os.getcwd(), modname)
        spec = importlib.util.spec_from_file_location(modname, p)
        if not spec:
            return
        foo = importlib.util.module_from_spec(spec)
        return spec.loader.exec_module(foo)

    def load_mod(self, name, mod=None):
        table[name] = mod or self.fromfile(name) or self.direct(name)
        return table[name]

    def unload(self, modname):
        if modname in table:
            del table[modname]
