""" logging module. """

__version__ = 1

def __dir__():
    return ("DumpHandler", "level")

## imports

import logging
import logging.handlers
import ob
import ob.utils
import os

## classes

class DumpHandler(logging.StreamHandler):

    propagate = False

    def emit(self, record):
        pass

## functions

def level(loglevel="error", logdir="", logfile="ob.log", nostream=False):
    if not logdir:
        logdir = os.path.join(ob.k.cfg.workdir, "logs")
    logfile = os.path.join(logdir, logfile)
    if not os.path.exists(logfile):
        ob.cdir(logfile)
    datefmt = '%H:%M:%S'
    format_time = "%(asctime)-8s %(message)-70s"
    format_plain = "%(message)-0s"
    loglevel = loglevel.upper()
    logger = logging.getLogger("")
    if logger.handlers:
        for handler in logger.handlers:
            logger.removeHandler(handler)
    if logger.handlers:
        for handler in logger.handlers:
            logger.removeHandler(handler)
    try:
        logger.setLevel(loglevel)
    except ValueError:
        pass
    formatter = logging.Formatter(format_plain, datefmt)
    if nostream:
        dhandler = DumpHandler()
        dhandler.propagate = False
        dhandler.setLevel(loglevel)
        logger.addHandler(dhandler)
    else:
        handler = logging.StreamHandler()
        handler.propagate = False
        handler.setFormatter(formatter)
        handler.setLevel(loglevel)
        logger.addHandler(handler)
    formatter2 = logging.Formatter(format_time, datefmt)
    filehandler = logging.handlers.TimedRotatingFileHandler(logfile, 'midnight')
    filehandler.propagate = False
    filehandler.setFormatter(formatter2)
    filehandler.setLevel(loglevel)
    logger.addHandler(filehandler)
    return logger
